#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

#import "..\\bin\\ps2pdfcom.exe"

static ps2pdfcom::_ps2pdf *PS2PDFCOMptr = NULL;

BOOL __stdcall VeryPDF_PS2PDF_InitializeLibrary()
{
	if(PS2PDFCOMptr)
		return TRUE;
	::CoInitialize(NULL);
	
	CLSID clsid;
	HRESULT hr;
	hr = CLSIDFromProgID(OLESTR("ps2pdfcom.ps2pdf"),&clsid);
	if (FAILED(hr))
	{
		return FALSE;
	}
	hr = CoCreateInstance(clsid,NULL,CLSCTX_LOCAL_SERVER,__uuidof(ps2pdfcom::_ps2pdf),(LPVOID *)&PS2PDFCOMptr);
	if (FAILED(hr))
	{
		return FALSE;
	}
	return TRUE;
}
void __stdcall VeryPDF_PS2PDF_UninitializeLibrary()
{
	if(PS2PDFCOMptr == NULL)
		return;
	if(PS2PDFCOMptr)
		PS2PDFCOMptr->Release();//Release
	PS2PDFCOMptr = NULL;
	::CoUninitialize();
}


void main(int argc, char *argv[])
{
	if(argc < 2)
	{
		printf("test.exe C:\\test.ps\n");
		printf("test.exe C:\\test.ps C:\\test.pdf\n");
		return;
	}
	if(!VeryPDF_PS2PDF_InitializeLibrary())
	{
		printf("VeryPDF_PS2PDF_InitializeLibrary() function failed.\n");
		return;
	}

	char *lpLicenseKey = "XXXXXXXXXXXXXXXXXX";
	char szCommandLine[2048] = {0};

	//sprintf(szCommandLine,"ps2pdf -mode 2 -$ \"%s\" ",lpLicenseKey);
	sprintf(szCommandLine,"ps2pdf -$ \"%s\" ",lpLicenseKey);
	for(int i = 1; i < argc; i++)
	{
		strcat(szCommandLine, " \"");
		strcat(szCommandLine, argv[i]);
		strcat(szCommandLine, "\"");
	}
	int nRet = 0;
	if(1)
		nRet = PS2PDFCOMptr->com_VeryPDF_PSToPDF(szCommandLine);
	else
	{
		char *lpszFiles[] = {
			"C:\\Test 2 Page.pdf",
			"C:\\Test 4 Page.pdf",
			"C:\\Test 6 Page.pdf"
		};
		for(i = 0; i < sizeof(lpszFiles)/sizeof(char*); i++)
		{
			sprintf(szCommandLine,"ps2pdf -$ \"%s\" -pdf2ps \"",lpLicenseKey);
			strcat(szCommandLine, lpszFiles[i]);
			strcat(szCommandLine, "\" \"");
			strcat(szCommandLine, lpszFiles[i]);
			strcat(szCommandLine, ".ps\"");
			nRet = PS2PDFCOMptr->com_VeryPDF_PSToPDF(szCommandLine);
			printf("nRet = %d, %s\n", nRet, szCommandLine);
		}
	}
	printf("nRet = %d\n", nRet);
	VeryPDF_PS2PDF_UninitializeLibrary();
}